/*Copyright (C) 2021, Mark Robillard Jr
 *
 * This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.*/

#include "CoreGame.cpp"
#include "RecordSave.cpp"
#include <iostream>
#include <string>
#include <stdio.h>
#include <stdlib.h>
#include <algorithm>

char simmenu(){
    char sim;
    std::cout << "Would you like to sim the game or play it? (s/p)\n";
    std::cin >> sim;
    return sim;
}

int main() {
    int humanpoints = 0;
    int cpupoints = 0;
    unsigned char any = 0;
    char simorplay;
    std::string humanteam;
    std::string cputeam;
    CoreGame Game;
    RecordSave result;

    std::cout << "Welcome to FreeBatter: A Baseball Simulator\nThis program is free software licensed under the GPLV3\nControls:\n(numbers 1 through 6) = hit/throw pitch.\n";
    std::cout << "(keys not 1 thru 6) = skip half inning.\n";
    std::cout << "Type the name of the Human team. (No spaces)\nExample:'Boston_Red_Sox'\n";
    std::cin >> humanteam;
    std::cout << "Type the name of the CPU team. (No spaces)\nExample:'New_York_Yankees'\n";
    std::cin >> cputeam;
    std::replace( humanteam.begin(), humanteam.end(), '_', ' ');
    std::replace( cputeam.begin(), cputeam.end(), '_', ' ');
    simorplay = simmenu();
    std::cin.ignore(10000, '\n');

    if (simorplay == 's'){
        for (double i = 1; i <= 9.5;){
    humanpoints = Game.simoffense(humanpoints);
    i+=0.5;
    cpupoints = Game.simdefense(cpupoints);
    i+=0.5;
  }

    if (humanpoints == cpupoints){
        for (double i = 10; humanpoints == cpupoints;){
            humanpoints = Game.simoffense(humanpoints);
            i+=0.5;

        if (humanpoints == cpupoints){
            cpupoints = Game.simdefense(cpupoints);
            i+=0.5;
       }
     }
   }
}
    else{
        for (double i = 1; i <= 9.5;){
        humanpoints = Game.offense(i,humanpoints, cpupoints,humanteam,cputeam);
        i+=0.5;
        cpupoints = Game.defense(i,humanpoints, cpupoints,humanteam,cputeam);
        i+=0.5;
  }

    if (humanpoints == cpupoints){
        for (double i = 10; humanpoints == cpupoints;){
        humanpoints = Game.offense(i,humanpoints, cpupoints, humanteam, cputeam);
        i+=0.5;

        if (humanpoints == cpupoints){
            cpupoints = Game.defense(i,humanpoints, cpupoints, humanteam, cputeam);
            i+=0.5;
        }
        }
   }
}
   std::cout <<"\nGame Results\n" << result.save(humanpoints, cpupoints, humanteam, cputeam);
   return 0;
}
